# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class OptionGroup(pulumi.CustomResource):
    """
    Provides an RDS DB option group resource. Documentation of the available options for various RDS engines can be found at:
    * [MariaDB Options](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Appendix.MariaDB.Options.html)
    * [Microsoft SQL Server Options](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Appendix.SQLServer.Options.html)
    * [MySQL Options](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Appendix.MySQL.Options.html)
    * [Oracle Options](https://docs.aws.amazon.com/AmazonRDS/latest/UserGuide/Appendix.Oracle.Options.html)
    """
    def __init__(__self__, __name__, __opts__=None, engine_name=None, major_engine_version=None, name=None, name_prefix=None, options=None, option_group_description=None, tags=None):
        """Create a OptionGroup resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not engine_name:
            raise TypeError('Missing required property engine_name')
        __props__['engine_name'] = engine_name

        if not major_engine_version:
            raise TypeError('Missing required property major_engine_version')
        __props__['major_engine_version'] = major_engine_version

        __props__['name'] = name

        __props__['name_prefix'] = name_prefix

        __props__['options'] = options

        option_group_description = 'Managed by Pulumi'
        __props__['option_group_description'] = option_group_description

        __props__['tags'] = tags

        __props__['arn'] = None

        super(OptionGroup, __self__).__init__(
            'aws:rds/optionGroup:OptionGroup',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

